Create Notification - m3ter Documentation

Create Notification

cURL

curl --request POST \
  --url https://api.m3ter.com/organizations/{orgId}/notifications/configurations \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "Commitment has under 10% remaining",
  "description": "Commitment amount fell below 10%",
  "code": "commitment_under_10_percent",
  "eventName": "configuration.commitment.updated",
  "version": 123,
  "active": true,
  "alwaysFireEvent": false,
  "calculation": "(new.amountSpent >= ((new.amount*90)/100)) \nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))"
}
  '

Python

import requests

url = "https://api.m3ter.com/organizations/{orgId}/notifications/configurations"

payload = {
    "name": "Commitment has under 10% remaining",
    "description": "Commitment amount fell below 10%",
    "code": "commitment_under_10_percent",
    "eventName": "configuration.commitment.updated",
    "version": 123,
    "active": True,
    "alwaysFireEvent": False,
    "calculation": "(new.amountSpent >= ((new.amount*90)/100))\nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: 'Commitment has under 10% remaining',
    description: 'Commitment amount fell below 10%',
    code: 'commitment_under_10_percent',
    eventName: 'configuration.commitment.updated',
    version: 123,
    active: true,
    alwaysFireEvent: false,
    calculation: '(new.amountSpent >= ((new.amount*90)/100)) \nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))'
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/notifications/configurations', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/notifications/configurations",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => 'Commitment has under 10% remaining',
    'description' => 'Commitment amount fell below 10%',
    'code' => 'commitment_under_10_percent',
    'eventName' => 'configuration.commitment.updated',
    'version' => 123,
    'active' => true,
    'alwaysFireEvent' => false,
    'calculation' => '(new.amountSpent >= ((new.amount*90)/100))\nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/notifications/configurations"

payload := strings.NewReader("{\n  \"name\": \"Commitment has under 10% remaining\",\n  \"description\": \"Commitment amount fell below 10%\",\n  \"code\": \"commitment_under_10_percent\",\n  \"eventName\": \"configuration.commitment.updated\",\n  \"version\": 123,\n  \"active\": true,\n  \"alwaysFireEvent\": false,\n  \"calculation\": \"(new.amountSpent >= ((new.amount*90)/100)) \\nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))\"\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Structure

{
  "id": "<string>",
  "name": "Commitment has under 10% remaining",
  "description": "Commitment amount fell below 10%",
  "code": "commitment_under_10_percent",
  "version": 123,
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>",
  "active": true,
  "alwaysFireEvent": false,
  "eventName": "configuration.commitment.updated",
  "calculation": "(new.amountSpent >= ((new.amount*90)/100)) \nAND ((old.amountSpent <= ((old.amount*90)/100)) OR (old.amountSpent == null))"
}

Error Responses

{
  "message": "<string>"
}